/* $Id: atr.c,v 1.12 2000/04/11 17:09:41 bodo Exp $ */
/*
    ChipDrive Library
    Copyright (C) 1997-2000  Bodo Bellut <bodo@bellutnet.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <sys/types.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>

#include "common.h"

#ifndef lint
static char vcid[] UNUSED = "$Id: atr.c,v 1.12 2000/04/11 17:09:41 bodo Exp $";
#endif /* lint */

int atr(int fd, BYTE *buf)
{
  int i;
  BYTE *retval;
  BYTE status;
  int protokoll = CD_PROT_UNKNOWN;

  retval = malloc(1*sizeof(BYTE));
  
  bzero(buf, 4*sizeof(BYTE));

  /* Status */
  write_cd(fd, 2, 0x03, 0x07);
  read_cd(fd, retval);
  status = *retval;
  read_cd(fd, retval);
  
  if (!((status >> 6) & 0x01))
    return -ECD_NOCARD;

  /* LED green */
  write_cd(fd, 5, 0x6f, 0x02, 0x6a, 0x0f, 0x5e);
  read_cd(fd, retval);

  /* activate */
  write_cd(fd, 3, 0x60, 0x0f, 0x9c);
  read_cd(fd, retval);
  
  /* read i2c starting at 0 */
  qs = 0;
  write_qs(fd, 9, 0x7c, 0x64, 0x41, 0xa0, 0x00, 0x64, 0x40, 0xa1, 0x0f);
  write_qs(fd, 1, qs);
  read_cd(fd, retval);
  
  /* read 4 bytes */
  qs = 0;
  write_qs(fd, 1, 0x13);
  write_qs(fd, 1, qs);
  for (i=0; i < 4 ; i++)
    read_qs(fd, &buf[i]);
  read_cd(fd, retval);

  /* ? */
  write_cd(fd, 4, 0x58, 0x65, 0x0f, 0x4e);
  read_cd(fd, retval);

  if (buf[0] == 0xff) {

    /* read 2-wire starting at 0 */
    write_cd(fd, 9, 0x70, 0x64, 0x42, 0x30, 0x00, 0x00, 0x65, 0x0f, 0xa0);
    read_cd(fd, retval);
    
    /* read 4 bytes */
    qs = 0;
    write_qs(fd, 1, 0x13);
    write_qs(fd, 1, qs);
    for (i=0; i < 4 ; i++)
      read_qs(fd, &buf[i]);
    read_cd(fd, retval);
    
    /* ? */
    write_cd(fd, 4, 0xa0, 0x80, 0x0f, 0x1e);
    read_cd(fd, retval);

    switch (buf[0] & 0xf0) {
    case 0x80: protokoll = CD_PROT_I2C;
    case 0x90: protokoll = CD_PROT_3WIRE;
    case 0xa0: protokoll = CD_PROT_2WIRE;
    }
    
  } else
    protokoll = CD_PROT_I2C;
  
  /* deactivate */
  write_cd(fd, 3, 0x61, 0x0f, 0x98);
  read_cd(fd, retval);
  
  /* LED off */
  write_cd(fd, 3, 0x6b, 0x0f, 0xb0);
  read_cd(fd, retval);

  free(retval);

  return protokoll;
  
}
