/* $Id: i2ctest.c,v 1.11 2000/04/11 17:09:41 bodo Exp $ */
/*
    ChipDrive Library
    Copyright (C) 1997-2000  Bodo Bellut <bodo@bellutnet.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "common.h"
#include "util.h"

#ifndef lint
static char vcid[] UNUSED = "$Id: i2ctest.c,v 1.11 2000/04/11 17:09:41 bodo Exp $";
#endif /* lint */

void main(void)
{
  int fd;
  int retval;
  BYTE *buf;

  fd = init_tty("/dev/ttyS0");

  buf = malloc(256*sizeof(BYTE));
  
  retval = i2c_read(fd, 2, 0, 256, buf);

  if (retval == -ECD_NOCARD) {
    close_tty(fd);
    printf("no card\n");
    free(buf);
    return;
  }

  dump(buf, 0, 0, 256);

#if 0
  printf("data:\n");
  for (j=0; j < 16; j++) {
    for (i=0; i < 16; i++)
      printf("%.2x ", buf[j*16+i]);
    printf("  ");
    for (i=0; i < 16; i++)
      printf("%c", ((buf[j*16+i] >= ' ') && (buf[j*16+i] <= '~'))? buf[j*16+i] : '.');
    printf("\n");
  }
#endif

#if 0
  for (i=0; i < 256; i++)
    buf[i] = i;

  retval = i2c_verify(fd, 2, 0, 256, buf);
  
  printf("verify: %sOK (%d)\n", retval ? "not " : "", retval);

  retval = i2c_write(fd, 2, 0, 256, buf);

  retval = i2c_read(fd, 2, 0, 256, buf);

  retval = i2c_verify(fd, 2, 0, 256, buf);
  
  printf("verify: %sOK (%d)\n", retval ? "not " : "", retval);

  dump(buf, 0, 0, 256);

#if 0
  printf("data:\n");
  for (j=0; j < 16; j++) {
    for (i=0; i < 16; i++)
      printf("%.2x ", buf[j*16+i]);
    printf("  ");
    for (i=0; i < 16; i++)
      printf("%c", (buf[j*16+i] >= ' ') ? buf[j*16+i] : '.');
    printf("\n");
  }
#endif

#endif

  close_tty(fd);
  
  free(buf);
}
