/* $Id: kvktest.c,v 1.7 2000/04/11 17:09:41 bodo Exp $ */
/*
    ChipDrive Library
    Copyright (C) 1997-2000  Bodo Bellut <bodo@bellutnet.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <stdlib.h>

#include "common.h"

#ifndef lint
static char vcid[] UNUSED = "$Id: kvktest.c,v 1.7 2000/04/11 17:09:41 bodo Exp $";
#endif /* lint */

void main(void)
{
  int fd;
  int retval;
  t_kvk *kvk;

  kvk = malloc(sizeof(t_kvk));

  fd = init_tty("/dev/ttyS0");
  retval = kvk_read(fd, kvk);

  close_tty(fd);

  if (retval == -ECD_NOCARD) {
    printf("no card\n");
    return;
  }

  if (retval == -ECD_NOSYS) {
    printf("protocol not implemented\n");
    return;
  }

  printf("data:\n");
  printf("Krankenkassen Name   : '%s'\n", kvk->kkName);
  printf("Krankenkassen Nummer : '%s'\n", kvk->kkNum);
  printf("VKNR                 : '%s'\n", kvk->VKNR);
  printf("Versicherten Nummer  : '%s'\n", kvk->vNum);
  printf("Versicherten Status  : '%s'\n", kvk->vStat);
  printf("Status Ergnzung O/W : '%s'\n", kvk->statOW);
  printf("Titel                : '%s'\n", kvk->titel);
  printf("Vorname              : '%s'\n", kvk->vorname);
  printf("Nameszusatz          : '%s'\n", kvk->namZus);
  printf("Familienname         : '%s'\n", kvk->famName);
  printf("Geburtsdatum         : '%s'\n", kvk->gebDat);
  printf("Strae und Nummer    : '%s'\n", kvk->strNum);
  printf("Wohnsitz Lndercode  : '%s'\n", kvk->wohnSLC);
  printf("PLZ                  : '%s'\n", kvk->PLZ);
  printf("Ort                  : '%s'\n", kvk->ort);
  printf("Gltigkeitsdatum     : '%s'\n", kvk->gueltig);
  printf("Prfsumme            : '%c'\n", kvk->checksum);

  free(kvk);
}
